
//		Copyright © 1999		Matthew S. Chartier (mattc@ic.net)
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//



#ifndef _H_PPA_LOWLEVEL
#define _H_PPA_LOWLEVEL

#include <SupportDefs.h>


// defines
#define 	IOPORT				0x378

#define   	DID_OK				0
#define   	DID_ABORT			1
#define	  	DID_RESET			2
#define	  	DID_TIME_OUT		3
#define	  	DID_BAD_TARGET		4
#define   	DID_NO_CONNECT		5
#define   	DID_ERROR			6

#define	  	STATUS_MASK			0x3e

#define   	READ_6				0x08
#define	  	READ_10				0x28
#define   	WRITE_6			    0x0a
#define	  	WRITE_10			0x2a

#define	  	PPA_INITIATOR		7
#define   	PPA_CAN_QUEUE       1
#define   	PPA_SELECT_TMO      5000
#define   	PPA_SPIN_TMO        5000000
#define   	PPA_SECTOR_SIZE     512

#define 	PPA_ZIP_LUN			6


// structures
typedef struct
	{
	int			target;
	int			cmd_len;
	char		cmnd[100];
	char		request_buffer[2048];
	int			request_bufflen;
	} Scsi_Cmnd;


// prototypes
void 		out_p(short port,char byte);
char		in_p(short port);
void 		ppa_d_pulse(char b);
void 		ppa_disconnect(void);
void 		ppa_c_pulse(char b);
void 		ppa_connect(void);
void 		ppa_do_reset(void);
int 		ppa_init(void);

status_t 	ppa_SendCommand(void* cmd,uint cmdlen,void* data,uint datalen);


#endif

